REM *****
REM THIS VERSION IS DESIGNED TO WORK WITH EFI02.ASM AND RUN ON THE 
REM ECU v6.1, NOT ON THE MICRO-440
REM *****
PRINT "ECU6.BAS"
;TRACE1
PRINT "MAIN ROUTINE BEGIN..."
REM *** ECU6.BAS ***
REM COMPILES WITH BEC-51 X-COMPILER FOR MICRO 440
REM CALCULATES PW BASED ON SENSOR INPUTS AND ENGINE STATUS (OP/CL LOOP,
REM SETS MICRO-440 BASED ON PW

GOSUB {INIT_VARS} :  REM INIT VARIABLES
GOSUB {FUEL_PUMP_CONTROL}  ; TURN ON FUEL PUMP
GOSUB {IAC_INIT}	;GET IAC POSITION AND SET TO DEFAULT IDLE
{MAIN}
REM * MAIN PROGRAM LOOP *
1000 GOSUB {GET_RPM} :  REM GET RPM
1005 CALL 0FE52H	;INITIATE A/D CONVERTER READ
1010 GOSUB {READ_MAP} :  REM READ MAP
1020 GOSUB {READ_CTEMP} :  REM READ CTEMP_SENSOR
1030 GOSUB {READ_EGO} : REM READ EGO (OXYGEN) SENSOR
1035 GOSUB {READ_TPS}	; READ TPS (THROTLE POSITION SENSOR)
1037 GOSUB {READ_VOLTS}	; READ BATTERY VOLTAGE
1040 GOSUB {CRANKING_CHECK} :  REM CHECK FOR CRANKING
1045 GOSUB {SET_IDLE}	; ADJUST IAC (IDLE SPEED)
1050 GOSUB {CHECK_CL_STAT}	; CHECK IF PARAMETERS ARE WITHIN LIMITS TO ENTER CLOSED LOOP MODE
1070 GOSUB {CALC_PW}:  REM CALCULATE PW
1080 GOSUB {SET_PW}: REM SET PW
   PRINT USING(####),
   PRINT "RPM=",RPM%," MAP=",MAP%," PW=",PW%, 
   PRINT USING(###),
   PRINT "IVV=",IVV%, : REM INJECTOR VOLUME VALUE (0-255, FROM TABLE)
   PRINT USING(##),
   PRINT "CLV=",CLV%, : REM COOLANT LOOKUP VALUE (PERCENT CORRECTION)
   PRINT "EGO=",EGO_SENSOR%(EGO_INDEX%), : REM CURRENT EGO SENSOR OUTPUT
   PRINT USING(###),
   PRINT "CLO=",CL_OFFSET%, : REM CLOSED LOOP OFFSET"
   PRINT "LV=",LEARNED_VALUE%,
  IF MORE%=-1 THEN {STAT_EXIT}	;SKIP EXTRA STATUS IF MORE% FLAG IS OFF
   PRINT
   PRINT "TPS=",TPS%,
   PRINT "IAC=",IAC_POS%,"VOLTS=",BV,"CL_MODE=",CL_MODE%,"TIME_NOW=",TIME_NOW
;  IF STEADY_TIMER_ON%=0 THEN PRINT:PRINT "       STEADY_TIMER_ON% = 0",
  {STAT_EXIT}
   PRINT
1090 GOTO {MAIN} :  REM END MAIN LOOP

STOP

{FUEL_PUMP_CONTROL}
REM * TURN ON FUEL PUMP *
PORT1=8FH  ;TURN ON FUEL PUMP, SP, KEY ON, CRANKING
RETURN

{IAC_INIT}
REM * DRIVE IAC TO LOWEST IDLE POSITION, INIT POSITION COUNTER, THEN BACK OUT TO DEFAULT IDLE *
CALL 0FE58H		; IAC_LOWER
FOR X=1 TO IAC_MAX%	;HOME IAC TO MIN IDLE
  CALL 0FE5AH	;IAC STEP
NEXT X
IAC_POS%=0	; ONCE IAC IS AT LOWEST IDLE, INIT POSITION COUNTER TO 0

REM NOW BACK IT OUT TO DEFAULT
CALL 0FE56H		;IAC HIGHER
FOR X=1 TO IAC_DEFAULT%	; DEFAULT IDLE
  CALL 0FE5AH	;IAC STEP
NEXT X
IAC_POS%=IAC_DEFAULT%	;SAVE CURRENT POSITION
IAC_NEW%=IAC_DEFAULT%	;SAVE CURRENT POSITION

CALL 0FE5CH		;IAC_OFF
RETURN

{GET_RPM}
REM * GET RPM *
REM EACH CLOCK TICK IS 1 USEC
REM RPM%=# OF USEC PER SECOND * # OF SECONDS PER MIN / # OF SPARKS PER REV. / TIME BETWEEN SPARKS
REM THE FOLLOWING PERFORMS THIS CALCULATION: RPM%=[1000000*60/SPARKS_PER_REV%/RPMPW]

LAST_RPM%=RPM% : REM REMEMBER RPM FROM LAST TIME THROUGH

RPMPW=DBY(RPMPWH%)*256+DBY(RPMPWL%) : REM GET TIME BETWEEN SP IN USEC
IF RPMPW=0 THEN RPM%=0 : GOTO {RPM_EXIT} : REM INVALID COUNT RETURNED, ENGINE PROBABLY NOT RUNNING
RPM1=USEC_MIN_SPARKS/RPMPW
IF RPM1>10000 THEN RPM1=10000 : REM RPMS ABOVE 32768 WILL CAUSE PROGRAM TO CRASH WHEN CHANGED TO INTEGER 
RPM%=INT(RPM1) : REM RPM1 MUST BE FLOATING POINT FOR ABOVE EQUATION TO EVALUATE CORRECTLY
IF RPM%<0 THEN PRINT"ERROR IN {GET_RPM}, RPM=", RPM% : RPM%=0 : GOTO {RPM_EXIT}

REM * CHECK FOR AND IGNORE EXTREME CHANGES IN RPM SINCE LAST TIME THROUGH {GET_RPM} *
IF ABS(RPM%-LAST_RPM%)<MAX_RPM_CHANGE% THEN IGNORED_RPM%=0: GOTO {RPM_EXIT}:REM IF RPM CHANGE IS NOT EXTREME, ACCEPT IT, RESET IGNORED_RPM% IF IT WAS SET
IF IGNORED_RPM%=1 THEN IGNORED_RPM%=0: GOTO {RPM_EXIT}:REM IF IT WAS IGNORED LAST TIME, DON'T INGNORE IT AGAIN
REM RPM CHANGE WAS MORE THAN MAX_RPM_CHANGE%
RPM%=LAST_RPM% : REM SET RPM TO PREVIOUS RPM
IGNORED_RPM%=1 : REM SET FLAG TO INDICATE THIS RPM WAS IGNORED

{RPM_EXIT}
REM ? "--",RPMPW,RPM
RETURN

{READ_MAP}
REM * READ MAP *
D%=XBY(MC%) :  REM READ MAP VALUE
MAP%=(21*D%)/51 :  REM CONVERT MAP VOLTS TO KPa
RETURN

{READ_CTEMP}
REM ** READ COOLANT TEMPERATURE SENSOR **
CTEMP_SENSOR%=XBY(CTC%)	; CTEMP VALUE
RETURN

{READ_EGO}
REM * READ EGO SENSOR *
EGO_INDEX%=EGO_INDEX%+1
IF EGO_INDEX%>EGO_VALUES% THEN EGO_INDEX%=1 :REM RESET COUNTER IF AT MAX
EGO_SENSOR%(EGO_INDEX%)=XBY(EGOC%) :  REM READ EGO SENSOR VALUE
RETURN

{READ_TPS}
TPS%=XBY(TPSC%)	;READ TPS VALUE
RETURN

{READ_VOLTS}
D%=XBY(BVC%)	;READ BATTERY VOLTAGE DATA
BV=D%/18	;CONVERT DATA TO VOLTS
RETURN

{CRANKING_CHECK}
REM * CHECK FOR CRANKING (STARTING) MODE *
REM * ST%=1 MEANS ENGINE IS RUNNING (HAS ALREADY BEEN STARTED)
ST%=(PORT1.AND.001H) :  REM IS ENGINE CRANKING? (P1.0 - ACTIVE LO)
;IF (RPM%>IDL%).AND.(RPM%<8000) THEN ST%=1 :  REM SET STARTED FLAG IF RUNNING
IF SCF%=1 THEN ST%=0 :  REM SIMULATED CRANKING
IF ST%=1 THEN SP_SYNC%=1 :  GOTO {CRANKING_EXIT} :  REM IF STARTED THEN SKIP
SP_SYNC%=0 :  REM SET INJ. MODE TO ASYNC.
PRINT "PRIMING...",
{CRANKING_EXIT}
RETURN

{SET_IDLE}
IF IAC_NEW%=IAC_POS% THEN {SET_IDLE_EXIT}	;IF NO CHANGE IN POSITION, THEN DON'T ADJUST
IAC_STEP%=IAC_POS%-IAC_NEW%	; GET DIFFERENCE TO STEP
IF IAC_STEP%<0 THEN {IAC_HIGHER}	;HIGHER SPEED, CONVERT

	{IAC_LOWER}
REM STEP MOTOR TO LOWER IDLE
CALL 0FE58H	;IAC_LOWER
FOR X=1 TO IAC_STEP%	; STEP IAC_STEP TIMES (STEPS ARE SMALL)
  CALL 0FE5AH	;IAC_STEP
NEXT X
CALL 0FE5CH	;IAC_OFF
IAC_POS%=IAC_POS%-IAC_STEP%
GOTO {SET_IDLE_EXIT}

	{IAC_HIGHER}
REM STEP IAC MOTOR TO HIGHER IDLE
IAC_STEP%=-IAC_STEP%	;CHANGE TO POS. VALUE
CALL 0FE56H	;IAC_HIGHER
FOR X=1 TO IAC_STEP%	; STEP IAC_STEP TIMES (STEPS ARE SMALL)
  CALL 0FE5AH	;IAC_STEP
NEXT X
IAC_POS%=IAC_POS%+IAC_STEP%
CALL 0FE5CH	;IAC_OFF

	{SET_IDLE_EXIT}
RETURN

{CHECK_CL_STAT}
REM * DETERMINE IF CLOSED LOOP MODE SHOULD BE ENABLED BASED ON: ENGINE RUNNING LONG ENOUGH,
REM * EGO HAVING REACHED A MINIMUM THRESHOLD AT LEAST ONCE (INDICATES IT'S WARM), AND THROTTLE
REM * NOT BEING OPEN PAST A CERTAIN MAX POSITION

IF CL_SKIP%=1 THEN CL_MODE%=0:GOTO {CHECK_CL_STAT_EXIT} ; REM SKIP OPEN LOOP MODE KEYBOARD-SELECTED

CL_MODE%=1	;INITIALLY SET CL FLAG (IT IS CLEARED IF PARAMETERS ARE UNACCEPTABLE)

IF ENGINE_ON_OK=1 THEN {CL_EGO_CHECK}	;SKIP ENGINE ON TIMER CHECK IF ALREADY PASSED
TIME_NOW = XBY(TICK15_MSB%)*256+XBY(TICK15_LSB%) : REM  CALCULATE TIME ENGINE HAS BEEN RUNNING
IF TIME_NOW-START_TIME > ENGINE_ON_MIN% THEN ENGINE_ON_OK=1 ELSE CL_MODE%=0:GOTO {CHECK_CL_STAT_EXIT}	;IF ENGINE IS ON LESS THAN MIN TIME LIMIT, DON'T ALLOW CL MODE

{CL_EGO_CHECK}
IF EGO_VALID%=1 THEN {CL_RPM_CHECK}   ;SET FLAG THE FIRST TIME EGO EXCEEDS MIN LIMIT (BUT DON'T RESET IT IF IT GETS LOWER LATER ON)
    REM AVERAGE RECENT EGO READINGS FOR GREATER ACCURACY
    EGO_AVERAGE%=0 : REM RESET BEFORE AVERAGING
    FOR X%=1 TO EGO_VALUES%
      EGO_AVERAGE%=EGO_AVERAGE%+EGO_SENSOR%(X%) : REM ADD UP RECENT EGO READINGS
    NEXT X%
    EGO_AVERAGE%=EGO_AVERAGE%/EGO_VALUES% : REM AVERAGE RECENT READINGS
IF EGO_AVERAGE%>CL_EGO_MIN% THEN EGO_VALID%=1 ELSE CL_MODE%=0:GOTO {CHECK_CL_STAT_EXIT}

{CL_RPM_CHECK}
IF RPM%=0 THEN CL_MODE%=0 : GOTO {CHECK_CL_STAT_EXIT}	; ENGINE NOT RUNNING

IF ST%=0 THEN CL_MODE%=0 : GOTO {CHECK_CL_STAT_EXIT}	; ENGINE IS CRANKING

IF TPS%>CL_TPS_MAX% THEN CL_MODE%=0	;IF THROTLE IS OPEN TOO MUCH, EXIT CL MODE

{CHECK_CL_STAT_EXIT}
RETURN

{CALC_PW}
REM ** CALCULATE PULSE WIDTH (PW) **

GOSUB {SIM_SENSOR} : POV%=SSI% : REM CHECK FOR SIMULATED SENSOR INPUT
IF ST%=0 THEN PW%=SPW% :  GOTO {CALC_PW_EXIT} :  REM USE PRESET PW IF CRANKING
REM ** LOOKUP INPUT VALUES IN TABLES **
REM * INJECTION PW (MAP & RPM --> PW) *
GOSUB {MAP_RPM_LOOKUP} :  REM SPECIAL 2-D LOOKUP TABLE, RETURNS IVV% (INJ. VOLUME VALUE)
IF CL_MODE%=1 THEN GOSUB {CHECK_TIMER_VARIATION}	; CHECK FOR VARIATION IN MAP OR RPM
REM * COOLANT TEMPERATURE LOOKUP VALUE (CLV%) *
GOSUB {CTEMP_LOOKUP}

REM ** CALCULATE PW BASED ON LOOKED UP VALUES **
OPW%=SC%*IVV% :  REM INTERMEDIATE PW BASED ON SCALING CONSTANT & LOOKUP PW
REM PRINT "OPW=",OPW%,: REM ORIGINAL PW
CTCV%=(OPW%/100)*CLV%:  REM COOLANT TEMP CORR. VALUE
OPW%=OPW%+CTCV%+POV% : REM ADD COOLANT TEMP TERM TO GET SEMI-FINAL PW & SSI OFFSET

REM * ADJUST FOR CLOSED LOOP AND LOOKUP LEARNED VALUE *
IF CL_MODE%=1 THEN GOSUB {CLOSED_LOOP} ELSE GOSUB {OPEN_LOOP} : REM ADJUST PW BASED ON EGO READING IF IN CL MODE, OR STRAIGHT LOOKUP IN OL MODE
GOSUB {LOOKUP_LEARNED_VALUE} : REM LOOKUP LEARNED OFFSET VALUE
PW%=OPW%+LEARNED_VALUE%+CL_OFFSET% : REM ADJUST PW FOR LEARNED OFFSET AND CLOSED LOOP EGO FEEDBACK

REM ? "POV, CTCV, SC, SC1",POV%,CTCV%,SC%,SC1%
IF (PW%<0) THEN PRINT "ERROR IN {CALC_PW}, PW=",PW% : PW%=DPW%: REM CAN'T HAVE NEG. PW'S

{CALC_PW_EXIT}
RETURN

{SET_PW}
PRINT ".", : REM INDICATE THAT {SET_PW} WAS EXECUTED FOR DEBUGGING
REM * SET PCA FOR CALCULATED PW *
T%=PW%/TS_USEC% :  REM NUMBER OF TIMER CLOCK TICKS IN DESIRED PW
MSB%=INT(T%/256) :  REM CALCULATE TIMER MSB
LSB%=INT(T%-MSB%*256) :  REM CALCULATE TIMER LSB
;print "T,MSB,LSB",T%,MSB%,LSB%
IF (MSB%<0) .OR. (MSB%>255) THEN PRINT "ERROR IN {SET_PW}, MSB=",MSB% : GOTO {SET_PW_EXIT}
IF (LSB%<0) .OR. (LSB%>255) THEN PRINT "ERROR IN {SET_PW}, LSB=",LSB% : GOTO {SET_PW_EXIT}
REM IF FIXED_PW%=1 THEN PRINT "FIXED PW",:GOTO {SYNC_MODE} : REM, SKIP SETTING PW IF IN FIXED MODE
DBY(PWL%)=LSB% : DBY(PWH%)=MSB% :  REM SET TIMER FOR COMPUTED PW

{SYNC_MODE}
REM CHANGE SYNC MODE IF NECESSARY
IF SP_SYNC%=OLD_SYNC% THEN {SET_PW_EXIT} :  REM SKIP IF SYNC MODE HASN'T CHANGED
OLD_SYNC%=SP_SYNC%
IF SP_SYNC%=0 THEN DBY(SYNC_ADR%)=DBY(SYNC_ADR%).AND.254 :  REM ASYNC MODE
IF SP_SYNC%=1 THEN DBY(SYNC_ADR%)=DBY(SYNC_ADR%).OR.1 :  REM SYNC MODE
PRINT  :  PRINT "SP_SYNC=",DBY(SYNC_ADR%)
CALL 0FE54H :  REM INIT SYNC/ASYNC MODE
{SET_PW_EXIT}
RETURN





{MAP_RPM_LOOKUP}
;IF VARIATION%=1 THEN {MAP_RPM_LOOKUP_EXIT}	; FOR SMALL VARIATIONS, SKIP LOOKUP (USE PREVIOUS VALUES)

MAP1% = MAP%: Rem CREATE UNIQUE VARIABLE FOR MAP
RPM1% = RPM%: Rem CREATE UNIQUE VARIABLE FOR RPM

Rem CHANGE OUT OF RANGE MAP & RPM TO MAX. AND MIN. VALUES
If MAP1% < MAP_MIN% Then MAP1% = MAP_MIN%
If MAP1% > MAP_MAX% Then MAP1% = MAP_MAX%
If RPM1% < RPM_MIN% Then RPM1% = RPM_MIN%
If RPM1% > RPM_MAX% Then RPM1% = RPM_MAX%

Rem CLOSEST MAP AND RPM VALUES IN TABLE
TABLE_LOW_MAP% = Int(MAP1% / MAP_INC%) * MAP_INC%
TABLE_HI_MAP% = TABLE_LOW_MAP% + MAP_INC%
TABLE_LOW_RPM% = Int(RPM1% / RPM_INC%) * RPM_INC%
TABLE_HI_RPM% = TABLE_LOW_RPM% + RPM_INC%

Rem BEGINNING OF MAP BLOCK + LOCATION OF RPM IN BLOCK
LOW_BLOCK_ADDR% = FT% + ((TABLE_LOW_MAP% - MAP_MIN%) / MAP_INC%) * RPM_VALS% + (TABLE_LOW_RPM% - RPM_MIN%) / RPM_INC%
HI_BLOCK_ADDR% = LOW_BLOCK_ADDR% + RPM_VALS%: Rem SAME PLACE IN NEXT BLOCK

RPM_INTERP_PERCENT% = ((RPM1% - TABLE_LOW_RPM%) * PCT%) / (TABLE_HI_RPM% - TABLE_LOW_RPM%): Rem PERCENT DISTANCE BETWEEN HI & LOW
MAP_INTERP_PERCENT% = ((MAP1% - TABLE_LOW_MAP%) * PCT%) / (TABLE_HI_MAP% - TABLE_LOW_MAP%): Rem PERCENT DISTANCE BETWEEN HI & LOW

LOW_MAP_IVV% = (((CBY(LOW_BLOCK_ADDR% + 1) - CBY(LOW_BLOCK_ADDR%)) * RPM_INTERP_PERCENT%) / PCT%) + CBY(LOW_BLOCK_ADDR%)
HI_MAP_IVV% = (((CBY(HI_BLOCK_ADDR% + 1) - CBY(HI_BLOCK_ADDR%)) * RPM_INTERP_PERCENT%) / PCT%) + CBY(HI_BLOCK_ADDR%)
REM TRUE_IVV% CORRESPONDS TO CURRENT CELL, BUT MAY BE BYPASSED AS IVV% IN {CHECK_TIMER_VARIATION}
TRUE_IVV% = (((HI_MAP_IVV% - LOW_MAP_IVV%) * MAP_INTERP_PERCENT% )/ PCT%) + LOW_MAP_IVV%

Rem IVV% = ((MAP1% - X1) / (X2 - X1) * (Z2 - Z1)) + Z1
Rem X1 & X2 ARE HI AND LOW INPUT VALUES, Z1 & Z2 ARE HI AND LOW LOOKED UP VALUES (OUTPUT)

{MAP_RPM_LOOKUP_EXIT}
RETURN

{CTEMP_LOOKUP}
REM CONVERTS A/D READING (CTEMP_SENSOR%) TO DEG F, THEN LOOKS UP COOLANT TEMP LOOKUP VALUE (CLV%)
REM IN A LOOKUP TABLE.

REM CONVERT A/D BYTE (CTEMP_SENSOR%) TO TEMP IN DEG. F.  DEPENDING ON THE TEMP RANGE, ONE
REM OF THREE DIFFERENT EQUATIONS ARE USED.  TO KEEP ALL INTERMEDIATE NUMERIC VALUES WITHIN
REM THE INTEGER VARIABLE RANGE, EQUATIONS HAVE BEEN MODIFIED.  THE EQUIVALENT EQUATION IS IN
REM THE REM OF EACH LINE.  THE CTEMP<32 EQUATION LOSES ACCURACY IN IT'S MODIFICATION, THE OTHERS
REM DO NOT.

IF CTEMP_SENSOR%<126 THEN CTEMP%=-1*CTEMP_SENSOR%+241:GOTO {CTEMP_TABLE}: REM CTEMP >122 DEG F, y=-1x+241
IF (CTEMP_SENSOR%>125) .AND. (CTEMP_SENSOR%<231) THEN CTEMP%=(-82*CTEMP_SENSOR%)/100+227:GOTO {CTEMP_TABLE}: REM CTEMP 32-122 DEG F,  y=-.82x+227
CTEMP%=(-343*(CTEMP_SENSOR%/3))/100*3+824 : REM CTEMP <32 DEG. F,  y=-3.34x+824

{CTEMP_TABLE}
REM KEEP CTEMP% IN TABLE RANGE 
IF CTEMP%<CTEMP_MIN% THEN CTEMP%=CTEMP_MIN%
IF CTEMP%>CTEMP_MAX% THEN CTEMP%=CTEMP_MAX% 
TABLE_LOW_CTEMP%=INT(CTEMP%/CTEMP_INC%)*CTEMP_INC%
TABLE_HI_CTEMP%=TABLE_LOW_CTEMP%+CTEMP_INC%


LOW_CLV_ADDR%=F_CTEMP%+(TABLE_LOW_CTEMP%+30)/10 : REM CONVERT TEMP TO INDEX, CALCULATE ADDR.
HI_CLV_ADDR%=LOW_CTEMP_ADDR%+1

;PRINT "CTEMP=",CTEMP%,LOW_CLV_ADDR%,CBY(LOW_CLV_ADDR%)

CLV_INTERP_PERCENT% = ((CTEMP% - TABLE_LOW_CTEMP%) * PCT%) / (TABLE_HI_CTEMP% - TABLE_LOW_CTEMP%): Rem PERCENT DISTANCE BETWEEN HI & LOW
CLV% = (((CBY(LOW_CLV_ADDR% + 1) - CBY(LOW_CLV_ADDR%)) * CLV_INTERP_PERCENT%) / PCT%) + CBY(LOW_CLV_ADDR%)

RETURN


{CHECK_TIMER_VARIATION}
REM CHECK STEADY TIMER AND ENGINE VARIATION
REM SEE IF STEADY TIMER IS RUNNING, IF NOT, START IT AND EXIT
REM IF IT WAS ALREADY RUNNING, THEN CHECK FOR MAP OR RPM VARIATION.  IF THERE IS A
REM VARIATION, DETERMINE IF IT IS LARGE OR SMALL.  IF IT IS SMALL, IT WILL BE IGNORED
REM BY THE TABLE LOOKUP ROUTINES.

REM DETERMINE IF ENGINE IS STEADY
VARIATION%=0 : REM RESET VARIATION FLAG
3000 IF STEADY_TIMER_ON% = 1 THEN GOTO {CL_CHECK_VARIATION} : REM IF ENGINE STEADY TIMER IS RUNNING, DON'T START IT
3010 REM * ENGINE NOT STEADY SO RESET AND START TIMER *
   STEADY_TIME% = 0 : REM RESET ENGINE STEADY TIMER
   STEADY_START = XBY(TICK15_MSB%)*256+XBY(TICK15_LSB%) : REM  GET STARTING COUNT FROM 15 ms COUNTER
   STEADY_TIMER_ON% = 1 : REM  FLAG THAT THE TIMER IS GOING

? "TIMER RESET - STEADY MAP, RPM, LADDR=",STEADY_MAP%,STEADY_RPM%,STEADY_LEARN_ADDR%
GOTO {CHECK_VAR_EXIT} : REM DON'T BOTHER CHECKING VARIATION SINCE TIMER HAS JUST STARTED

{CL_CHECK_VARIATION}
REM VARIATION= (0 FOR NO VARIATION, 1 FOR SMALL VARIATION, 2 FOR LARGE VARIATION)
IF LOW_BLOCK_ADDR% - FT% + LTABLE1%<>STEADY_LEARN_ADDR% THEN VARIATION%=1: REM IF ADDR POINTS TO A DIFFERENT CELL IN LEARNING TABLE AT LEAST A SMALL VARIATION HAS OCCURRED
IF ABS(MAP% - STEADY_MAP%) > MAX_MAP_VAR% THEN VARIATION%=2	; IF MAP VARIATION IS BEYOND SMALL VARIATION LIMIT, SET FLAG TO INDICATE LARGE VARIATION
IF ABS(RPM% - STEADY_RPM%) > MAX_RPM_VAR% THEN VARIATION%=2	; IF RPM VARIATION IS BEYOND SMALL VARIATION LIMIT, SET FLAG TO INDICATE LARGE VARIATION
IF VARIATION%=1 THEN ? "v",
{CHECK_VAR_EXIT} 
RETURN


{CLOSED_LOOP}
REM This routine adjusts PW based on EGO (Exhaust Gas Oxygen) sensor output
REM to keep mixture as close to stoich. as possible.  
REM It uses a range just as the sensor starts indicating lean to aim for.

PRINT "+",	;INDICATE THAT CL WAS EXECUTED

IF VARIATION%<>2 THEN {NO_VARIATION}	;CHECK FOR LARGE VARIATION
REM * ENGINE IS NOT STEADY (LARGE VARIATION WAS DETECTED) *
?:PRINT "+++ VARIATION +++"
3040 STEADY_TIMER_ON% = 0 : REM STOP TIMER

REM BACK OFF CL_OFFSET TO PREVIOUS VALUE (WHICH WAS VALIDATED BY EGO READING) & CONVERT TO STORED_VALUE%
3060 IF ABS(CL_OFFSET%)<=ADJUST_STEP% THEN {CL_AFTER_VLEARN} : REM ADJUSTMENT WAS NEVER VALIDATED BEFORE VARIATION, SO FORGET IT

3070 REM * VARIATION OCCURRED, BUT SOME VALIDATED CORRECTION WAS MADE, SO SAVE IT IN LEARNING TABLE *
     ? "VAR LEARN ADDR=",STEADY_LEARN_ADDR%
LEARNED_VALUE% = LEARNED_VALUE%+CL_OFFSET%-CL_STEP% : REM SUBTRACT PREVIOUS ADJUSTMENT THAT WAS NOT VALIDATED AND XFER OFFSET TO LEARNED VALUE
GOSUB {CL_LEARN}	; LEARN CURRENT LEARNED_VALUE% IN STEADY_LEARN_ADDR%

{CL_AFTER_VLEARN}
GOSUB {LOOKUP_LEARNED_VALUE} ;NOW THAT VARIATION OCCURRED (AND OLD LV LV WAS LEARNED), GET NEW LV
? "STEADY=",STEADY_MAP%,STEADY_RPM%,STEADY_LEARN_ADDR%

IF EGO_AVERAGE% < CLO_RESET_EGO% THEN {SKIP_CLO_RESET} : REM IF EGO IS VERY LEAN, DON'T RESET CL OFFSET DURING VARIATION

{CLO_RESET}
CL_OFFSET%=0 : REM RESET SINCE VARIATION OCCURRED (NO LONGER VALID FOR ENGINE STATE)

{SKIP_CLO_RESET}
   CL_STEP%=0 : REM RESET SINCE VARIATION OCCURRED (NO LONGER VALID FOR ENGINE STATE)
REM USE NEW IVV, AND RESET STEADY VARS FOR LARGE VARIATION ONLY (OTHERWISE THEY SHOULD BE THE SAME)
   IVV%=TRUE_IVV%		;SET IVV TO VALUE LOOKED UP FOR LARGE VARIATION ONLY
   STEADY_LEARN_ADDR% = LOW_BLOCK_ADDR% - FT% + LTABLE1% : REM LEARNING TABLE ADDR TO PUT LEARNED OFFSET IN (SUBTRACT MAIN TABLE START ADDR, ADD LEARNING TABLE START ADDR)
   STEADY_MAP% = MAP% : REM SAVE CURRENT MAP TO SEE IF IT IS STEADY (USE ORIGINAL STEADY MAP FOR SMALL VARIATIONS)
   STEADY_RPM% = RPM% : REM SAVE CURRENT RPM TO SEE IF IT IS STEADY (USE ORIGINAL STEADY RPM FOR SMALL VARIATIONS)

GOTO {CL_EXIT}

{NO_VARIATION}
REM ENGINE IS STEADY, NOW SEE IF IT HAS BEEN STEADY FOR LONG ENOUGH
   TIME_NOW= (XBY(TICK15_MSB%)*256+XBY(TICK15_LSB%))  ;CURRENT TICK15 TIME
   STEADY_TIME% = INT(TIME_NOW - STEADY_START) : REM ELAPSED TIME SINCE STEADY CHECK BEGAN
    IF STEADY_TIME% < EGO_DELAY% THEN {CL_EXIT} : REM ENGINE NOT STEADY FOR LONG ENOUGH, YET.
REM ENGINE STEADY FOR AT LEAST EGO_DELAY TIME SO ADJUST PW BASED ON EGO OUTPUT
    EGO_AVERAGE%=0 : REM RESET BEFORE AVERAGING
    FOR X%=1 TO EGO_VALUES%
      EGO_AVERAGE%=EGO_AVERAGE%+EGO_SENSOR%(X%) : REM ADD UP RECENT EGO READINGS
    NEXT X%
    EGO_AVERAGE%=EGO_AVERAGE%/EGO_VALUES% : REM AVERAGE RECENT READINGS

REM * SET EGO LIMITS BASED ON MAP AND RPM  FOR IDLE AND NORMAL *
IF MAP%<28 .AND. RPM%<1200 THEN RICH_LIMIT%=RI_LIMIT% : LEAN_LIMIT%=LI_LIMIT% : GOTO {CL_STEP_SET} : REM IF IDLING, SET IDLE LIMITS
RICH_LIMIT%=RN_LIMIT% :REM SET RICH NORMAL LIMIT
LEAN_LIMIT%=LN_LIMIT% :REM SET LEAN NORMAL LIMIT 

{CL_STEP_SET}
3080    IF EGO_AVERAGE% > RICH_LIMIT% THEN CL_STEP% = -ADJUST_STEP% : GOTO {CL_ADJUST} : REM STEP TOWARD LEAN IF TOO RICH (NOTE "-" BEFORE A) , THEN EXIT
3090    IF EGO_AVERAGE% < LEAN_LIMIT% THEN CL_STEP% = ADJUST_STEP%*2 : GOTO {CL_ADJUST} : REM STEP TOWARD RICH IF TOO LEAN, THEN EXIT
3095    CL_STEP%=0 : REM EGO WITHIN LIMITS, NO ADJUSTMENT NECESSARY

REM * LEARN CL OFFSET IN LEARNING TABLE *
  REM VALUE IN LIMITS, SAVE TO LEARNING TABLE
  REM LOCATION TO STORE VALUE IN IS BASED ON ROW AND COL CALCULATION OF ORIGINAL LOOKUP VALUES
REM LEARNED VALUE IS NOT INTERPOLATED ON AT ALL, THE CELL IT IS PUT IN CORRESPONDS TO THE NEAREST
REM MAP AND RPM ON THE LOW SIDE OF THEORETICAL LOCATION.

3150 REM * NO VARIATION, SAVE OFFSET IN LEARNING TABLE *
LEARNED_VALUE%=LEARNED_VALUE%+CL_OFFSET%: REM UPDATE CURRENT LEARNED_VALUE% SINCE CL_OFFSET% WILL BE CLEARED
GOSUB {CL_LEARN}	; LEARN CURRENT LEARNED_VALUE% IN STEADY_LEARN_ADDR%
CL_OFFSET%=0 : REM RESET OFFSET SINCE IT IS INCORPORATED IN LEARNED VALUE

{CL_ADJUST}     
3200 STEADY_TIMER_ON% = 0 : REM WAIT FOR PW CHANGE TO BE REFLECTED BY EGO BEFORE ADJUSTING AGAIN
CL_OFFSET%=CL_OFFSET%+CL_STEP% : REM CUMULATIVELY ADJUST OFFSET EACH TIME THROUGH

{CL_EXIT}  
3300 REM EXIT
RETURN

{CL_LEARN}	; LEARN CURRENT LEARNED_VALUE% IN STEADY_LEARN_ADDR%
IF CLV%>8 THEN {CL_LEARN_EXIT} : REM DON'T LEARN UNLESS ENGINE IS WARM (FOR NOW)
STORED_VALUE% = (LEARNED_VALUE%/ADJUST_STEP%)+LEARNING_OFFSET% : REM SCALE CL OFFSET FOR TABLE STORAGE
IF STORED_VALUE%>255 .OR. STORED_VALUE%<0 THEN PRINT "STORED VALUE ERROR = ",STORED_VALUE%
XBY(STEADY_LEARN_ADDR%)=STORED_VALUE% : REM SAVE LEARNED VALUE
? "Learned: ",STEADY_LEARN_ADDR%,"=",LEARNED_VALUE%
{CL_LEARN_EXIT}
RETURN

{LOOKUP_LEARNED_VALUE}
  3400 CELL_VALUE%=XBY(STEADY_LEARN_ADDR%)
  LEARNED_VALUE% = (CELL_VALUE%-LEARNING_OFFSET%) * ADJUST_STEP% : REM CONVERT TABLE VALUE TO CL OFFSET 
RETURN

{OPEN_LOOP}
REM DO STRAIGHT LOOKUP WHEN IN OPEN LOOP MODE
   IVV%=TRUE_IVV%		;SET IVV TO VALUE LOOKED UP FOR LARGE VARIATION ONLY
   STEADY_LEARN_ADDR% = LOW_BLOCK_ADDR% - FT% + LTABLE1% : REM LEARNING TABLE ADDR TO PUT LEARNED OFFSET IN (SUBTRACT MAIN TABLE START ADDR, ADD LEARNING TABLE START ADDR)
   STEADY_MAP% = MAP% : REM SAVE CURRENT MAP TO SEE IF IT IS STEADY (USE ORIGINAL STEADY MAP FOR SMALL VARIATIONS)
   STEADY_RPM% = RPM% : REM SAVE CURRENT RPM TO SEE IF IT IS STEADY (USE ORIGINAL STEADY RPM FOR SMALL VARIATIONS)
   CL_OFFSET%=0	; RESET OFFSET IF IN OPEN LOOP MODE
RETURN

{INIT_VARS}
REM * INIT LOOKUP VARIABLES *
PRINT "==========================================="

REM * MAIN TABLE ADDRESSES (Code memory)*
FT%=7000H : REM FIRST MAIN FUEL MAP TABLE ENTRY
SC_ADDR%=FT%+528 : REM SCALING CONSTANT ADDRESS
F_CTEMP%=FT%+529 : REM FIRST CTEMP TABLE ENTRY
VALIDATE_ADDR%=FT%+561 : REM ADDRESS OF VALIDATION BYTES (SHOULD EQUAL 0ABH AND 0BCH)

REM * LEARNING TABLE ADDRESSES (External RAM)*
LTABLE1% = 2000H : REM LEARNING TABLE 1 START ADDRESS
LTABLE2% = 2233H : REM LEARNING TABLE 2 START ADDRESS
LTABLE3% = 2466H : REM LEARNING TABLE 3 START ADDRESS

REM * LOOKUP TABLE SPECS *
MAP_MIN% = 8: Rem Min. MAP value in table
MAP_MAX% = 100: Rem Max. MAP value in table
MAP_INC% = 4: Rem MAP increment
RPM_MIN% = 300: Rem Min. RPM value in table
RPM_MAX% = 6600: Rem Max. RPM value in table
RPM_INC% = 300: Rem RPM increment
RPM_VALS% = (RPM_MAX% - RPM_MIN%) / RPM_INC% + 1: Rem Total number of RPMs in each MAP block

CTEMP_MIN%=-40 : REM MIN CTEMP VALUE IN TABLE
CTEMP_MAX%=270 : REM MAX CTEMP VALUE IN TABLE
CTEMP_INC%=10 : REM CTEMP INCREMENT (DEG F)
SC%=CBY(SC_ADDR%) : REM SCALING CONSTANT PW=IVV*SC (IN USEC)
IF SC%=0 THEN PRINT"INVALID SC%=0":SC%=40: REM INVALID SC%, SET TO DEFAULT

REM VERIFY TABLE DATA (LAST TWO ADDRESSES SHOULD BE 171 AND 205)
IF (CBY(VALIDATE_ADDR%)<>0ABH) .OR. (CBY(VALIDATE_ADDR%+1)<>0CDH) THEN PRINT "!!! WARNING: FUEL MAP IS INVALID!!!",CBY(VALIDATE_ADDR%),CBY(VALIDATE_ADDR%+1):PRINT CHR$(7):PRINT CHR$(7)

REM * ISR (EFI00.ASM) INIT CONTROL VARIABLES, PORTS & TIMER *
REM ISR INIT ROUTINE ENTRY ADDRESS IS FE50H
REM ISR SYNC ROUTINE ENTRY ADDRESS IS FE54H
SYNC_ADR%=21H :  REM ADDRESS OF SP_SYNC% BIT (FOR ASM ROUTINE)
REM AVAILABLE INTERNAL RAM IS HOPEFULLY FROM 4Eh-5Fh
PWL%=01AH : PWH%=PWL%+1 :  REM INJ. PW ADDRESS
RPMPWL%=01CH : RPMPWH%=RPMPWL%+1 :  REM RETURNED SP WIDTH
ASYNC_PERIOD% = 01EH : REM ASYNC MODE PERIOD BETWEEN PULSES (LSB, MSB)
DBY(ASYNC_PERIOD%)=48:DBY(ASYNC_PERIOD%+1)=117 : REM SET ASYNC PERIOD BETWEEN PULSES TO 30 MS

REM * ASM ROUTINE ADDRESSES FOR CALLS *

CALL 0FE50H :  REM Call EFI02.ASM's INIT.

REM * A/D AND I/O ADDRESSES *
TICK15_LSB%=0FFF6H ; 15ms counter address LSB
TICK15_MSB%=TICK15_LSB%+1 ; 15ms counter address MSB
AD%=0FFF8H :  REM A/D CONVERTER BASE ADDR. (MIRRORED)
BVC%=AD% ;BATTERY VOLTAGE CHANNEL (ADC #0)
MC%=AD%+1 :  REM ADC MAP CHANNEL (ADC #1)
CTC%=AD%+2 :  REM ADC CTEMP_SENSOR CHANNEL (ADC #2)
TPSC%=AD%+3 : REM TPS SENSOR CHANNEL (ADC #3)
EGOC%=AD%+4 : REM ADC EGO_SENSOR CHANNEL (ADC #4)

REM * IAC REALTED VARS *
IAC_MAX%=500	; MAX STEPS FOR FULL IAC TRAVEL (MIN IDLE TO MAX IDLE)
IAC_DEFAULT%=150	; DEFAULT STEPS TO INCREASE IAC FOR STANDARD IDLE
;IDLE_SPEED%=800	; DEFAULT IDLE RPM
;IDLE_SPEED_VAR%=50	;RPM VARIATION ALLOWED IN IDLE SPEED BEFORE RE-ADJUSTING IAC
IAC_INC%=5		; NUMBER OF STEPS TO MOVE IAC FOR EACH ADJUSTMENT

REM * TPS RELATED VARS *
TPS_MIN%=0	;MIN TPS POSITION (CLOSED THROTTLE)
TPS_MAX%=255	;MAX TPS POSITION (WOT)
;TPS_IDLE%=10	;LIMIT TO INDICATE TPS IS NOT IN IDLE POSITION (FULL CLOSED)

REM * PW RELATED VARS *
REM NOTE THAT ALL PW VALUES ARE IN MICROSECONDS (USEC)
REM EACH TIMER TICK IS 1 USEC ALSO
TS_USEC%=1 :  REM TIMER SPEED IN usec (DURATION OF EACH TICK)
SP_SYNC%=0 : OLD_SYNC%=1 :  REM INITIAL INJECTOR MODE - ASYNC FOR STARTING
ST%=0 :  REM ENGINE STARTED (RUNNING) FLAG - INIT W/ENGINE STOPPED
IDL%=600 :  REM MIN. IDLE SPEED BEFORE ENRICHMENT
SPW%=6000 :  REM STARTING PW
DPW%=2000 :  REM DEFAULT. PW FOR ERROR IN PW
IVV%=30 : REM INITIAL PW

REM * RPM RELATED VARS *
CYL%=8 : REM NUMBER OF CYLINDERS
SPARKS_PER_REV%=(CYL%/2) : REM NUMBER OF SPARKS PER REVOLUTION
USEC_PER_MIN=60000000 : REM NUMBER OF USEC PER MINUTE
USEC_MIN_SPARKS=USEC_PER_MIN/SPARKS_PER_REV% : REM SPARKS PER MINUTES WORTH OF USEC
MAX_RPM_CHANGE%=1000 : REM MAX ALLOWABLE CHANGE IN RPM BETWEEN TWO EXECUTIONS OF {GET_RPM}
RPM%=0 : REM INITIAL RPM VALUE
LAST_RPM%=0 : REM REMEMBER THE RPM FROM THE LAST TIME THROUGH {GET_RPM}

REM * CLOSED LOOP VARS *
LN_LIMIT% = 35 : REM EGO NORMAL LEAN LIMIT
RN_LIMIT% = 40 : REM EGO NORMAL RICH LIMIT
LI_LIMIT% = 35 : REM EGO IDLE LEAN LIMIT
RI_LIMIT% = 40 : REM EGO IDLE RICH LIMIT
ADJUST_STEP% = 25 : REM increment by which to adjust PW (in usec).  May be about 5% of avg. PW?
EGO_DELAY% = 66 : REM NUMBER OF 15ms TICKS ENGINE MUST BE STEADY BEFORE ATTEMPTING CLOSED LOOP ADJUSTMENTS (66=1 sec.)
MAX_MAP_VAR% = 4 ;VARIATION IN MAP ALLOWED WHILE CLO WILL BE ADJUSTED TO KEEP PW AS IT WAS PRIOR TO VARIATION
MAX_RPM_VAR% = 300 ;VARIATION IN RPM ALLOWED WHILE CLO WILL BE ADJUSTED TO KEEP PW AS IT WAS PRIOR TO VARIATION
STEADY_TIMER_ON% = 0 : REM FLAG TO INDICATE THAT ENGINE IS CONSIDERED STEADY-STATE (BASED ON MAP & RPM)
EGO_VALUES%=5 : REM NUMBER OF EGO READINGS TO AVERAGE
DIM EGO_SENSOR%(10) : REM ARRAY TO STORE PREVIOUS EGO VALUES IN FOR AVERAGING
EGO_INDEX%=0 : REM ARRAY INDEX FOR EGO_SENSOR%(X)

LEARNING_OFFSET%=200 : REM AMOUNT TO SHIFT LEARNED VALUE BY TO GIVE NON-NEGATIVE VALUE
CL_FIRST%=1 : REM FLAG TO INDICATE 1ST TIME THROUGH CLOSED LOOP ROUTINE
CLO_RESET_EGO%=25 : REM EGO LIMIT BELOW WHICH C.L. OFFSET WON'T BE RESET, DESPITE VARIATION

REM * CLOSED LOOP MODE ACTIVATION RELATED VARS *
ENGINE_ON_MIN%=100	;NUMBER OF COUNTS ENGINE MUST BE ON BEFORE GOING INTO CL MODE (8000=~120 SECS.)
CL_EGO_MIN%=35	;MIN EGO VALUE BEFORE GOING INTO CL MODE
CL_TPS_MAX%=150	;MAX TPS VALUE BEFORE COMING OUT OF CL MODE
EGO_VALID%=0	;FLAG TO INDICATE IF EGO OUTPUT HAS REACHED A VALID LEVEL (I.E. SENSOR IS WARM)
ENGINE_ON_OK=0	;FLAG TO INDICATE IF ENGINE RUN TIMER HAS PASSED MIN VALUE
CL_MODE%=0		;FLAG TO INDICATE IF CLOSED LOOP MODE IS ACTIVE

REM * KEYBOARD INPUT VARS *
SSI%=0 :  REM SIM SENSOR INPUT FLAG
FIXED_PW%=0 : REM FLAG TO MAKE MAIN LOOP SKIP SETTING PW
LOCK%=0 : REM FLAG TO LOCK KEYBD FROM SUBSEQUENT SSI INPUT
DSPV%=0 : REM DEFAULT SIM PW VALUE
MORE%=-1	; FLAG TO INDICATE DISPLAYING MORE STATUS VAUES (2 LINES)

REM * CONSTANTS USED IN MATH *
PCT% = 100: Rem FACTOR TO CONVERT DECIMALS TO INTEGERS AND BACK

ENGINE_START = XBY(TICK15_MSB%)*256+XBY(TICK15_LSB%) : REM  GET ENGINE STARTING (ACTULLY, KEY ON) COUNT FROM 15 ms COUNTER
PRINT "ENGINE_START TIME=",ENGINE_START
RETURN


{SIM_SENSOR}
REM +++ SIMULATED SENSOR INPUT +++
IF LOCK%=1 THEN {SIM_EXIT} : REM SKIP IF LOCKED
CH%=GET
IF CH%=0 THEN {SIM_EXIT}
IF CH%=30H THEN SSI%=DSPV% :  REM "0", SET TO DEFAULT SIM PW VALUE
IF CH%=31H THEN SSI%=SSI%-100 :  REM "1"
IF CH%=32H THEN SSI%=SSI%+100 :  REM "2"
IF CH%=33H THEN SSI%=SSI%-1000 :  REM "3"
IF CH%=34H THEN SSI%=SSI%+1000 :  REM "4"
IF CH%=53H THEN SCF%=1 :  REM "S" STARTING CHEAT FLAG (SIMULATES KEY TO START)
IF CH%=52H THEN SCF%=0 :  REM "R"
IF CH%=46H THEN FIXED_PW%=1 : REM "F" FIXED PW MODE. SKIPS ACTUAL SETTING OF PW (IT IS STILL CALCULATED)
IF CH%=4EH THEN FIXED_PW%=0 : REM "N" RESTORE NORMAL PW SETTING MODE (IF IT WAS IN SKIP MODE)
IF CH%=4CH THEN LOCK%=1 : REM "L" LOCK KEYBOARD FROM SUBSEQUENT SSI CHARS.

IF CH%=4FH THEN CL_SKIP%=1 : CL_FIRST%=1:  PRINT "OPEN LOOP": REM "O" OPEN LOOP (SKIP CLOSED LOOP), SET FLAG FOR 1ST TIME THROUGH AFTER CLOSED LOOP IS ENABLED
IF CH%=43H THEN CL_SKIP%=0 : PRINT "CLOSED LOOP": REM "C" CLOSED LOOP (DON'T SKIP CLOSED LOOP)
IF CH%<>44H THEN {SSI_CONT} : REM "D" DUMP LOOKUP TABLES
  PRINT: PRINT "MAIN LOOKUP TABLE"
  FOR X%=FT% TO FT%+205H STEP RPM_VALS%
	FOR Y%=0 TO RPM_VALS%-1	;NUMBER OF CELLS IN EACH COL. OF MAPs
        PRINT CBY(X%+Y%),
	NEXT Y%
	PRINT
  NEXT X%
  PRINT: PRINT "LEARNING TABLE 1"
  FOR X%=LTABLE1% TO LTABLE2%-1 STEP RPM_VALS%
	FOR Y%=0 TO RPM_VALS%-1	;NUMBER OF CELLS IN EACH COL. OF MAPs
        PRINT XBY(X%+Y%),
	NEXT Y%
	PRINT
  NEXT X%
  PRINT:PRINT

{SSI_CONT}
IF CH%=58H THEN PORT1=0BH:PRINT"FUEL PUMP OFF"  ; "X" TURN FUEL PUMP OFF
IF CH%=2DH THEN IAC_NEW%=IAC_POS%-IAC_INC%	; "-" STEP IAC TO LOWER RPM
IF CH%=3DH THEN IAC_NEW%=IAC_POS%+IAC_INC%	; "=" STEP IAC TO HIGHER RPM
IF CH%=4DH THEN MORE%=-MORE%	;FLAG TO INDICATE DISPLAYING MORE STATUS VALUES
PRINT "SSI =",SSI%
PRINT
IF CH%<>5AH THEN {SIM_EXIT} : REM "Z" - ZEROS LEARNING TABLE1
  FOR X%=LTABLE1% TO LTABLE2%-1
    XBY(X%)=LEARNING_OFFSET% : REM STORE VALUE THAT REPRESENTS ZERO
  NEXT X%
  PRINT "LEARNING TABLE 1 CLEARED"

{SIM_EXIT}
RETURN


